#!/bin/sh
#
#  ESMPRO ServerAgentService
#     esmpostinst.sh Version: 1.3 (2023/06/20)
#

WORKPATH="/opt/nec/esmpro_sa/registry/HKEY_LOCAL_MACHINE/SOFTWARE/NEC/ESMALERTMAN/REPORTTABLE/EVENTLOG/APPLICATION/ESMCOMMONSERVICE"
RESTPATH="/usr/local/lib/python3.6/site-packages/redfish/rest"
LOGPATH="/opt/nec/esmpro_sa/log/install_python-library.log"
TOOLSPATH="/opt/nec/esmpro_sa/tools/"
ERR_FLAG=0

DisableTempLowerAction()
{
    TARGETPATH="${WORKPATH}/C0000066/EVENTSETTING"

    if [ ! -d "${TARGETPATH}" ] ; then
        echo "ERROR: ${TARGETPATH} is not exist."
        ERR_FLAG=1
    else
        REGACTION="${TARGETPATH}/V_ACTION"
        /bin/echo -ne "\x04\x00\x00\x00\x04\x00\x00\x00" > "${REGACTION}" 2>/dev/null
        /bin/echo -ne "\x00\x00\x00\x00" >> "${REGACTION}" 2>/dev/null
    fi

    TARGETPATH="${WORKPATH}/C0000070/EVENTSETTING"

    if [ ! -d "${TARGETPATH}" ] ; then
        echo "ERROR: ${TARGETPATH} is not exist."
        ERR_FLAG=1
    else
        REGACTION="${TARGETPATH}/V_ACTION"
        /bin/echo -ne "\x04\x00\x00\x00\x04\x00\x00\x00" > "${REGACTION}" 2>/dev/null
        /bin/echo -ne "\x00\x00\x00\x00" >> "${REGACTION}" 2>/dev/null
    fi
}

ChangeClassXml()
{
    REPLACEFILENAME="${CURRENTDIR}/chgxml/class.xml"
    FILENAME="/opt/nec/esmpro_sa/data/class.xml"

    if [ -f ${FILENAME} ]; then
        if [ -f ${REPLACEFILENAME} ]; then
            /bin/cp -af ${REPLACEFILENAME} ${FILENAME} 2>/dev/null
        fi
    fi
}
#process

CURRENTDIR=$0
CURRENTDIR=${CURRENTDIR%/*}

ChangeClassXml

REPLACE_FILE=`ls ${CURRENTDIR}/sh/*.sh 2>/dev/null `
if [ -n "${REPLACE_FILE}" ] && [ -d "${TOOLSPATH}" ] ; then
    /usr/bin/chmod 755 ${CURRENTDIR}/sh/*.sh
    /bin/cp -af ${CURRENTDIR}/sh/*  ${TOOLSPATH} 2>/dev/null
    if [ -f "${CURRENTDIR}/sh/esmsasgencert.sh" ] ; then
        if ! /bin/grep "UPGRADE" /etc/esmpro/Esmpro-Provider.log >/dev/null 2>&1 ; then
            /bin/rm -rf /etc/openwsman/servercert.pem 2>/dev/null
            /bin/rm -rf /etc/openwsman/serverkey.pem 2>/dev/null
            /bin/sh /opt/nec/esmpro_sa/tools/esmsasgencert.sh >/dev/null 2>&1
        fi
    fi
fi

if /bin/uname -r 2>/dev/null|/bin/grep "4\\.18\\.0-.*el8" >/dev/null 2>&1 ; then
    if [ -f ${RESTPATH}/v1.py ] ; then
        cd ${RESTPATH}
        /bin/cp -af v1.py v1.py.bak 2>/dev/null
        /bin/sed -i 's/excp\.message/str\(excp\)/g' v1.py
        if [ -f ${LOGPATH} ] ; then
            /bin/echo "${RESTPATH}/v1.py: change excp.message to str(excp)." >> ${LOGPATH} 2>&1
        fi
    fi
fi

EXSITEDSAPVD=`/bin/rpm -qa --qf '%{name}-%{version}-%{release}.%{arch}.rpm\n' 2>/dev/null|/bin/grep "Esmpro-Cmnsrv" 2>/dev/null`
if [ ! -z "$EXSITEDSAPVD" ] ; then
    DisableTempLowerAction
fi


if [ "${ERR_FLAG}" == "1" ] ; then
    exit 1
fi
exit 0
