#!/bin/bash
#
#  ESMPRO ServerAgentService
#    esmsasgencert.sh Version: 1.03 (2022/08/03)
#

HOSTNAME=""


if [ -f /etc/openwsman/servercert.pem ] || [ -f /etc/openwsman/serverkey.pem ]; then
	/bin/echo "Certificate exists! Exit."
	exit 1
fi

if [ ! -f /etc/openwsman/owsmangencert.sh ]; then
	/bin/echo "ERROR: Can't find /etc/openwsman/owsmangencert.sh to create certificate! Exit."
	exit 1
fi

if [ ! -f /etc/openwsman/ssleay.cnf.esmbak ]; then
	/bin/cp -a /etc/openwsman/ssleay.cnf /etc/openwsman/ssleay.cnf.esmbak >/dev/null 2>&1
fi

if [ -f /bin/uname ]; then
	HOSTNAME=`/bin/uname -n 2>/dev/null`
fi

if [ -z "$HOSTNAME" ]; then
	HOSTNAME="localhost.localdomain"
fi
#Begin:RQ2110 20190618 for RHEL8: default_bits 1024 -> 2048
#if /bin/uname -r 2>/dev/null|/bin/grep "4\\.18\\.0-.*el8" >/dev/null 2>&1 ; then
#Modify for RHEL9.0 RQ3204 202207 
if /bin/uname -r 2>/dev/null|/bin/grep "4\\.18\\.0-.*el8" >/dev/null 2>&1 || /bin/uname -r 2>/dev/null|/bin/grep ".*el8uek" >/dev/null 2>&1 || /bin/uname -r 2>/dev/null|/bin/grep "5\\.14\\.0-.*el9" >/dev/null 2>&1; then
  /bin/cat > /etc/openwsman/ssleay.cnf 2>/dev/null << ESMEOF
RANDFILE                = /dev/urandom
   
   
[ req ]
default_bits            = 2048
default_keyfile         = privkey.pem
distinguished_name      = req_distinguished_name
prompt                  = no
   
[ req_distinguished_name ]
countryName             = GB
stateOrProvinceName     = Some-State
commonName              = $HOSTNAME
   
ESMEOF

  /etc/openwsman/owsmangencert.sh >/dev/null 2>&1

else
#End:RQ2110 20190618 for RHEL8: default_bits 1024 -> 2048
  /bin/cat > /etc/openwsman/ssleay.cnf 2>/dev/null << ESMEOF
RANDFILE                = /dev/urandom
   
   
[ req ]
default_bits            = 1024
default_keyfile         = privkey.pem
distinguished_name      = req_distinguished_name
prompt                  = no
   
[ req_distinguished_name ]
countryName             = GB
stateOrProvinceName     = Some-State
commonName              = $HOSTNAME
   
ESMEOF
  /etc/openwsman/owsmangencert.sh >/dev/null 2>&1
  /bin/rm -f /etc/openwsman/ssleay.cnf >/dev/null 2>&1
  /bin/mv /etc/openwsman/ssleay.cnf.esmbak /etc/openwsman/ssleay.cnf >/dev/null 2>&1

fi
exit 0

